--local debug = true
require("isDebug")
data:extend({
	{
		type = "battery-equipment",
	    name = "suit-plug",
	    sprite =
	    {
	      filename = "__Suit-Plug__/graphics/PlugMale.png",
	      width = 32,
	      height = 32,
	      priority = "medium"
	    },
	    shape =
	    {
	      width = 1,
	      height = 1,
	      type = "full"
	    },
	    energy_source =
	    {
	      type = "electric",
	      buffer_capacity = "100MJ",
	      input_flow_limit = "1GW",
	      output_flow_limit = "1GW",
	      usage_priority = "terciary"
	    }
	},
	{
			type = "battery-equipment",
		    name = "lite-suit-plug",
		    sprite =
		    {
		      filename = "__Suit-Plug__/graphics/PlugMale-R.png",
		      width = 32,
		      height = 32,
		      priority = "medium"
		    },
		    shape =
		    {
		      width = 1,
		      height = 1,
		      type = "full"
		    },
	        energy_source =
		    {
		      type = "electric",
		      buffer_capacity = "0J",
		      input_flow_limit = "0MW",
		      output_flow_limit = "0MW",
		      usage_priority = "terciary"
		    }
		},
	{
		type = "accumulator",
		name = "suit-outlet-station",
		icon = "__Suit-Plug__/graphics/large_suit_outlet_icon.png",
		flags = {"placeable-neutral", "placeable-player", "placeable-enemy",
			"player-creation"},
		minable = {hardness = 1, mining_time = 10, result = "suit-outlet-station"},
		max_health = 15000,
		collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
		selection_box = {{-1, -1}, {1, 1}},
		corpse = "medium-remnants",
		energy_source =
		{
			type = "electric",
			buffer_capacity = "5GJ",
			usage_priority = "terciary",
			input_flow_limit = "2GW",
			output_flow_limit = "2GW"
	    },
	    charge_cooldown = 30,
	    discharge_cooldown = 0,
	    resistances =
	    {
	      {
	        type = "fire",
	        percent = 50
	      }
	    },
		picture ={
			filename = "__Suit-Plug__/graphics/large_suit_outlet.png",
			priority = "extra-high",
			width = 124,
			height = 103,
			shift = {0.7, -0.2}
		},
	    charge_animation =
	    {
	      filename = "__Suit-Plug__/graphics/large_suit_outlet-charge-animation.png",
	      width = 138,
	      height = 135,
	      line_length = 8,
	      frame_count = 24,
	      shift = {0.482, -0.638},
	      animation_speed = 0.5
	    },
	    charge_cooldown = 30,
	    charge_light = {intensity = 0.3, size = 7},
	    discharge_animation =
	    {
	      filename = "__Suit-Plug__/graphics/large_suit_outlet-discharge-animation.png",
	      width = 147,
	      height = 128,
	      line_length = 8,
	      frame_count = 24,
	      shift = {0.395, -0.525},
	      animation_speed = 0.5
	    },
	    discharge_cooldown = 60,
	    discharge_light = {intensity = 0.7, size = 7},
	    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	    working_sound =
	    {
	      sound =
	      {
	        filename = "__base__/sound/accumulator-working.ogg",
	        volume = 1
	      },
	      idle_sound = {
	        filename = "__base__/sound/accumulator-idle.ogg",
	        volume = 0.4
	      },
	      max_sounds_per_type = 5
	    },
	},
	{
		type = "accumulator",
		name = "suit-outlet-personal",
		icon = "__Suit-Plug__/graphics/Outlet_small.png",
		flags = {"placeable-neutral", "placeable-player", "placeable-enemy",
			"player-creation"},
    	minable = {hardness = 0.1, mining_time = 0.1, result = "suit-outlet-personal"},
		max_health = 150,
		collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
		selection_box = {{-1, -1}, {1, 1}},
		corpse = "medium-remnants",
		energy_source =
		{
			type = "electric",
			buffer_capacity = "5MJ",
			usage_priority = "terciary",
			input_flow_limit = "10MW",
			output_flow_limit = "10MW"
		},
	    charge_cooldown = 30,
	    discharge_cooldown = 0,
	    resistances =
	    {
	      {
	        type = "fire",
	        percent = 50
	      }
	    },
		picture ={
			filename = "__Suit-Plug__/graphics/Outlet.png",
			priority = "extra-high",
			width = 64,
			height = 64,
		},
	    discharge_light = {intensity = 0.7, size = 7},
	    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	    working_sound =
	    {
	      sound =
	      {
	        filename = "__base__/sound/accumulator-working.ogg",
	        volume = 1
	      },
	      idle_sound = {
	        filename = "__base__/sound/accumulator-idle.ogg",
	        volume = 0.4
	      },
	      max_sounds_per_type = 5
	    },
	}
})
if debug then
	data:extend({
		{
			type = "solar-panel",
			name = "power-cheat",
			icon = "__Suit-Plug__/graphics/PlugMale.png",
			flags = {"placeable-neutral", "placeable-player", "placeable-enemy",
				"player-creation"},
			energy_source =
			{
				type = "electric",
				usage_priority = "solar",
			},
			production = "999GW",
			max_health = 99999999,
			picture ={
				filename = "__Suit-Plug__/graphics/electrical_outlet_lineart.png",
				priority = "high",
				width = 42,
				height = 65,
				direction_count=1
			},
			minable = {hardness = 0.2, mining_time = 0.25, result = "power-cheat"},
		},
		{
			type = "recipe",
			name = "power-cheat",
			ingredients = {{"iron-plate", 1}},
			result = "power-cheat"
		},
		{
			type = "item",
			name = "power-cheat",
			subgroup = "energy-pipe-distribution",
			stack_size=10,
			icon = "__Suit-Plug__/graphics/electrical_outlet_lineart.png",
			place_result = "power-cheat",
			order = "a[energy]-a[suit-outlet]",
			flags = {"goes-to-quickbar"}
		}
	})
end
