require "table"
require "math"
require ("isDebug")

local playerArmorInventory = defines.inventory.player_armor --constant
local STATION = "suit-outlet-station"
local PERSONAL = "suit-outlet-personal"
local searchRadius = 20 --constant
--for outline reasons
--personalStations = nil
--print(debug)
--function On_Load()
--	personalStations = global["outlet-personal"]
--	if not personalStations then
--		personalStations = {{}}
--		global["outlet-personal"] = personalStations
--	end
----	if not
--end
--TODO: make it so the player must place the thing on top of them and prevent them from moving
function checkArmor(player, armor)
	if (not player.connected) then
		--debugPrint(player.name .. " is not connected")
		return --can't do anything to a unconnected player....
	end
	local character = player.character
	if not character then
		--debugPrint(player.name .. " does not have a character")
		return
	end
	local armor = character.get_inventory(playerArmorInventory)[1];
	--making this fair makes it hard, so it will not be fair.....
	if not armor or not armor.valid_for_read or not armor.has_grid then
		--debugPrint(player.name .. " does not have armor on")
		return
	end
	--player.print("player check")
	local grid = armor.grid
	local plugs = {}
	local batteries = {}
	local plugCount = 0
	for i, equipment in ipairs(grid.equipment) do
		--stupid lua....
		if equipment.name == "suit-plug" or equipment.name == "lite-suit-plug" then
			--player.print(equipment.name)-- I know that works....
			table.insert(plugs, equipment)
			table.insert(batteries, equipment)
			plugCount = plugCount + 1
--		else
--			plugs[plugs.size] = equipment
--			plugs.size = plugs.size + 1
		elseif equipment.type == "battery-equipment" then
			table.insert(batteries, equipment)
		end
--		plugs[i] = equipment
--		player.print(equipment.name)
	end
	if (plugCount < 1) then
		return
	end
	--does the player need power?
	local powerNeeded = 0 --note: powerNeeded is a float
	for i, battery in pairs(batteries) do
		local powerMissing = battery.max_energy - battery.energy
		powerNeeded = powerNeeded + powerMissing
	end
	if (powerNeeded <= 0) then
		return
	end
	debugPrint(player.name .. " is missing " .. powerNeeded .. " power.")
	--find suit outlet stations
	local playerPos = character.position
	local searchArea = {
		{playerPos.x - searchRadius, playerPos.y - searchRadius},
		{playerPos.x + searchRadius, playerPos.y + searchRadius}
	}
	local largeOutlets = character.surface.find_entities_filtered{
			area = searchArea,
			name = STATION
		}
	debugPrint("Found " .. #largeOutlets .. " suit outlets near " .. player.name)
	for i, outlet in pairs(largeOutlets) do
		powerNeeded = consumePower(powerNeeded, outlet, batteries)
	end

	--find smaller ones
	local smallSearchRadius = 1
	searchArea = {
		{playerPos.x - smallSearchRadius, playerPos.y - smallSearchRadius},
		{playerPos.x + smallSearchRadius, playerPos.y + smallSearchRadius}
	}
	local smallOutlets = character.surface.find_entities_filtered{
		area = searchArea,
		name = PERSONAL
	}
	debugPrint("Found " .. #smallOutlets .. " personal suit outlets near " .. player.name)
	for i, outlet in pairs(smallOutlets) do
		powerNeeded = consumePower(powerNeeded, outlet, batteries)
	end
--	player.print(plugs.size)
--	for i, equipment in ipairs(plugs) do
--		player.print(2 .. equipment.name)
--	end
end

function consumePower(powerNeeded, outlet, batteries)
	local powerTaken = powerNeeded - outlet.energy
	if (powerTaken <= 0) then -- this node satisfies our needs
		powerTaken = powerNeeded
	end
	debugPrint("Taking " .. powerTaken .. " from suit outlet")
	outlet.energy = outlet.energy - powerTaken
	for i, battery in pairs(batteries) do
		local missingPower = battery.max_energy - battery.energy
		if (missingPower > 0) then
			local plugPowerTaken = missingPower - powerTaken
			if (plugPowerTaken <= 0) then
				plugPowerTaken = missingPower --top this one off
			end
			debugPrint("Adding " .. plugPowerTaken .. " to battery")
			battery.energy = battery.energy + plugPowerTaken
			powerNeeded = powerNeeded - plugPowerTaken
		end
	end
	return powerNeeded
end
--
--function itemPlaced(item, player)
--	--TODO: implement
--	if (item.name ~= PERSONAL) then
--		return
--	end
--	if (personalStations[player] ~= nil or player == nil) then
--		return
--	end
--	game.players[player].active=false
--	personalStations[player]=item
----	if (item.name == STATION) then
----		table.insert(stations, item)
----	elseif item.name == PERSONAL then
----		table.insert(personalStations, item)
----	end
----	if (debug) then
----		if not player == nil then
----			game.players[player].print("You placed a " .. item.name)
----		else
----			print("A " .. item.name .. " was placed")
----		end
----	end
--end

--function itemRemovalPending(item, player)
--	if (item.name ~= PERSONAL) then
--		return
--	end
--	local index = remove(personalStations, item)
--	if (index > -1) then
--		game.players[index].active=true
--	end
----	if debug then
----		if not player == nil then
----			game.players[player].pring("You removed a " .. item.name)
----		else
----			print("A " .. item.name .. " was removed")
----		end
----	end
----	if (item.name == STATION) then
----		remove(stations, item)
----	elseif (item.name == PERSONAL) then
----		remove(personalStations, item)
----	end
--end

--function itemRemovalCanceled(item)pre_mined is called right before the item is removed
--	print("removal of " .. item.type .. " was canceled")
--end

--function itemRemoved(stack, player)
--	if (stack.name ~= STATION and stack.name ~= PERSONAL) then
--		return
--	end
--	--remove invalid
--	local toRemove = {{}}
--	for k,v in iPairs(stations) do
--		if (v.surface == nil) then
--			print("A " .. v.name .. " was removed")
--			table.insert(toRemove, v)
--		end
--	end
--
--	for k,v in iPairs(toRemove) do
--		remove(stations, v)
--		remove(personalStations, v)
--	end
--end

function remove(table, item)
	local index = -1
	for key,value in pairs(table) do
		if (value == item) then
			index = key
		end
	end
	if (index > -1) then
		table.remove(table, index)
		return index
	end
	return -1
end

function debugPrint(data)
	if (debug) then
		print(data)
	end
end

function printTable(table, prefixIn)
	local prefix = prefixIn or ""
--	if prefix == nil then preifx = "" end
	for k,v in pairs(table) do
		if (type(v) == "table") then
			printTable(v, prefix .. "." .. k)
		elseif type(v) == "userdata" then
			print(k .."=<userdata>")
		elseif v == nil then
			print(k .. "=nil")
		else
--			print(type(v))
			print(k .. "=" .. v)
		end
	end
end
